/* ###################################### */
/* #                                    # */
/* #  Un compilateur pour le langage    # */
/* #        ALGO                        # */
/* #                                    # */
/* # Machine RISC                       # */
/* # Emmanuel Bruno                     # */
/* # 1999-2006                          # */
/* # bruno@univ-tln.fr                  # */
/* ###################################### */

#include "algo_risc.h"

/* Affichage en binaire d'un entier */
/* Prend en paramtre l'entier "nb" dont on veut afficher la dcomposition */
void int2bin(unsigned int nb)
{
  int i;
  unsigned int masque = 1 << 31;
  for(i=0;i<32;i++)
    {
      if (nb & masque) printf("1");
      else printf("0");
      nb=nb<<1;
    }
}

/* Procdure d'criture du code */
/* Ecrit dans le tableau "code", l'entier correspondant  l'instruction dsigne par "op" */
/* avec les paramtres "a","b","c" */
/* Met  jour la variable globale "lastinst" qui indique la position de la dernire instruction */
/* mise dans "code" */
void put(unsigned int op,unsigned int a,unsigned int b, int c)
{
  /* ATTENTION BIEN PENSER EN ENCODER le bit de signe ventuel de "c" */

  /* --- A COMPLETER --- */

}

/* Procdure de chargement du code en mmoire */
/* Copie les "len" premires instructions contenues dans le tableau "code" */
/* Dans le tableau "M" qui reprsente la mmoire de la machine RISC */ 
void load(unsigned int *code,int len)
{

  /* --- A COMPLETER --- */

  printf("--- Code charg en memoire. ---\n");
}

/* Procdure qui dcode l'instruction "inst" passe en paramtre et qui affecte */
/* aux paramtres pass par adresse les valeurs du code oprations et des paramtres a,b,c */ 
void decodeinst(unsigned int inst,unsigned int *opc,unsigned int *a,unsigned int *b, int*c)
{

  /* --- A COMPLETER --- */

}

/* Affichage des "len" premires instructions du programme assembleur "code" */
/* sous forme code ET dcode */
void decode(unsigned int *code,int len)
{
  int i;
  unsigned int inst,opc,a,b;
  int c;
  printf("--- Code Machine ---\n");
  /* --- A COMPLETER --- */
}

/* Procdure d'excution du code  partir de l'adresse PC0 en mmoire */
void execute(unsigned int PC0)
{
  unsigned int opc,a,b; 
  int c;
  /* L'adresse variable "suivant" indique quelle sera la prochaine instruction */
  unsigned int suivant;

  /* Initialisation des registres 0 et 31 */
  R[0]=0;
  R[31]=0;

  /* IMPORTANT Attention l'adressage est en Octet mais le tableau qui */
  /* reprsente la mmoire est un tableau d'entiers */
  PC=PC0/4;

  /* Boucle d'excution principale */
  /* excute les instructions jusqu' la fin du programme */

  do     
    {

      /* Chargement de l'instruction  excuter dans IR */
      /* --- A COMPLETER --- */

      /* Incrmentation du compteur ordinal PC */
      /* --- A COMPLETER --- */

      /* Appel de la fonction de dcodage des instructions */
      /* --- A COMPLETER --- */
      
      /* Affichage de l'instruction qui va tre excute */
      printf("((%s\t%d,%d,%d [%d]))\n",mnemo[opc],a,b,c,PC);

      /* Execution de l'instruction */
      switch (opc)
	{
	case i_add  : /* --- A COMPLETER --- */;break;
	case i_addi : /* --- A COMPLETER --- */;break;
	case i_sub  : /* --- A COMPLETER --- */;break;
	case i_subi : /* --- A COMPLETER --- */;break;
	case i_cmp  : /* --- A COMPLETER --- */ ;break;
	case i_cmpi : /* --- A COMPLETER --- */;break;
	case i_mul  : /* --- A COMPLETER --- */;break;
	case i_muli : /* --- A COMPLETER --- */;break;
	case i_div  : /* --- A COMPLETER --- */;break;
	case i_divi : /* --- A COMPLETER --- */;break;
	case i_mod  : /* --- A COMPLETER --- */;break;
	case i_modi : /* --- A COMPLETER --- */;break;
	case i_or   : /* --- A COMPLETER --- */;break;
	case i_ori  : /* --- A COMPLETER --- */ ;break;
	case i_and  : /* --- A COMPLETER --- */ ;break;
	case i_andi : /* --- A COMPLETER --- */;break;
	case i_bic  : /* --- A COMPLETER --- */;break;
	case i_bici : /* --- A COMPLETER --- */ ;break;
	case i_xor  : /* --- A COMPLETER --- */;break;
	case i_xori : /* --- A COMPLETER --- */;break;
	case i_lsh  : /* --- A COMPLETER --- */;break;
	case i_lshi : /* --- A COMPLETER --- */;break;
	case i_ash  : /* Optionnel */;break;
	case i_ashi : /* Optionnel */;break;
	case i_chk  : /* --- A COMPLETER --- */;break;
	case i_chki: /* --- A COMPLETER --- */;break;
	case i_ldw			  : /* --- A COMPLETER --- */;break;
	case i_ldb			  : /* Optionnel */;break;
	case i_pop			  : /* --- A COMPLETER --- */;break;
	case i_stw			  : /* --- A COMPLETER --- */;break;
	case i_stb			  : /* Optionnel */;break;
	case i_psh			  : /* --- A COMPLETER --- */;break;
	case i_beq			  : /* --- A COMPLETER --- */;break;
	case i_bne			  : /* --- A COMPLETER --- */;break;
	case i_blt			  : /* --- A COMPLETER --- */;break;
	case i_ble			  : /* --- A COMPLETER --- */;break;
	case i_bgt			  : /* --- A COMPLETER --- */;break;
	case i_bge			  : /* --- A COMPLETER --- */;break;
	case i_bsr			  : /* --- A COMPLETER --- */;break;
	case i_jsr			  : /* --- A COMPLETER --- */;break;
	case i_ret			  : /* --- A COMPLETER --- */;break;
	case i_rd			  : /* --- A COMPLETER --- */;break;
	case i_wrd			  : /* --- A COMPLETER --- */;break;
	case i_hrs                        : break;
	default: 
	  {
	    printf("ERREUR instruction inconnue!!!!\n");
	    exit();
	  }
	}
      PC=suivant;
    } while (opc != i_hrs);
  printf("\n--- Fin de l'excution du code ---\n");
}


/* Stocke les codes mnemoniques (chaine de caractere)  l'indice
	correspondant dans le tableau mnemo */
void init_mnemo(int code, char* code_mnemo) {
	mnemo[code]=(char*)(malloc(sizeof(char)*(strlen(code_mnemo)+1)));
	strcpy(mnemo[code], code_mnemo);
}

void risc_init()
{
  int i;
  printf("Check: size of int: %d\n",sizeof(i));
  /* INITIALISATION */
  lastinst=0;   
  for (i=0;i<32;i++) R[i]=0; 
  SP=0;

  /* Tableau des codes mnemoniques */
  /* A utiliser pour afficher le nom des oprations */
  init_mnemo(i_add,"ADD" );init_mnemo(i_sub,"SUB" );init_mnemo(i_mul,"MUL" );init_mnemo(i_div,"DIV" );
  init_mnemo(i_mod,"MOD" );init_mnemo(i_cmp,"CMP" );init_mnemo(i_chk,"CHK" );init_mnemo(i_and,"AND" );
  init_mnemo(i_bic,"BIC" );init_mnemo(i_or,"OR"  );init_mnemo(i_xor,"XOR" );init_mnemo(i_lsh,"LSH" );
  init_mnemo(i_ash,"ASH" );

  init_mnemo(i_addi , "ADDI");init_mnemo(i_subi, "SUBI");init_mnemo(i_muli, "MULI");init_mnemo(i_divi, "DIVI");
  init_mnemo(i_modi , "MODI");init_mnemo(i_cmpi, "CMPI");init_mnemo(i_chki, "CHKI");init_mnemo(i_andi, "ANDI");
  init_mnemo(i_bici , "BICI");init_mnemo(i_ori,"ORI" );init_mnemo(i_xori, "XORI");init_mnemo(i_lshi, "LSHI");
  init_mnemo(i_ashi , "ASHI");

  init_mnemo(i_ldw,"LDW" );init_mnemo(i_ldb,"LDB" );init_mnemo(i_pop,"POP" );init_mnemo(i_stw,"STW" );
  init_mnemo(i_stb,"STB" );init_mnemo(i_psh,"PSH" );

  init_mnemo(i_beq,"BEQ" );init_mnemo(i_bne,"BNE" );init_mnemo(i_blt,"BLT" );init_mnemo(i_bge,"BGE" );
  init_mnemo(i_bgt,"BGT" );init_mnemo(i_ble,"BLE" );

  init_mnemo(i_bsr,"BSR" );init_mnemo(i_jsr,"JSR" );init_mnemo(i_ret,"RET" );

  init_mnemo(i_hrs,"HRS" );

  init_mnemo(i_rd ,"RD"  );init_mnemo(i_wrd,"WRD" );
}






