/* ###################################### */
/* #                                    # */
/* #  Un compilateur pour le langage    # */
/* #        ALGO                        # */
/* #                                    # */
/* # Machine RISC                       # */
/* # BRUNO Emmanuel 1999-2006           # */
/* # bruno@univ-tln.fr                  # */
/* ###################################### */

/* ### Procdure d'criture du code ### */
void put(unsigned int op,unsigned int a,unsigned int b, int c);

/* Chargement d'un code de longueur "len" en mmoire */
void load(unsigned int *code,int len);

/* Excution du code (dj charg en mmoire)  partir de l'adresse PC0*/
void execute(unsigned int PC0);

/* Affichage des codes mnmoniques d'un programme assembleur de longueur len*/
void decode(unsigned int *code,int len);

/* Affichage en binaire d'un entier */
void int2bin(unsigned int);

/* Initialisation de la machine RISC */

/* ### Dclarations ### */
#define taille_memoire  1024
#define taille_code  1000

/* Codes Operateurs */
#define i_add   0  
#define i_sub   1  
#define i_mul   2  
#define i_div   3  
#define i_mod   4  
#define i_cmp   5  
#define i_chk   6 
#define i_and   7  
#define i_bic   8 
#define i_or    9  
#define i_xor   10 
#define i_lsh   11 
#define i_ash   12 

#define i_ret   13 /* ATTENTION */

#define i_addi  14 
#define i_subi  15 
#define i_muli  16 
#define i_divi  17 
#define i_modi  18 
#define i_cmpi  19 
#define i_chki  20 
#define i_andi  21 
#define i_bici  22 
#define i_ori   23 
#define i_xori  24 
#define i_lshi  25 
#define i_ashi  26 

#define i_ldw   27 
#define i_ldb   28 
#define i_pop   29 
#define i_stw   30 
#define i_stb   31 
#define i_psh   32 

#define i_beq   33 
#define i_bne   34 
#define i_blt   35 
#define i_bge   36 
#define i_bgt   37 
#define i_ble   38 
#define i_bsr   39 

#define i_hrs   40

#define i_rd    41 
#define i_wrd   42

#define i_jsr   43 


/* position de la dernire instruction dans le tableau code */
int  lastinst; 
/*Compteur Ordinal et registre instruction */
unsigned int  PC,IR;
/* Tableau permettant de simuler les registres de la machines RISC*/
int  R[32];
/* Tableau permettant de simuler la mnmoire */
unsigned int  M[taille_memoire / 4];
/* Tableau contenant du code assembleur (pour la gnration de code)*/
unsigned int  code[taille_code];
/* Table des codes mnemoniques (pour un affichage lisible) */
char *mnemo[54];
/* dernier registre libre (simulation de pile pour la gnration de code) */
int  SP;
